//
//  SecondViewController.m
//  PaintCode
//
//  Created by Felipe on 5/21/13.
//  Copyright (c) 2013 Felipe Laso Marsetti. All rights reserved.
//

#import "ProgressView.h"
#import "ProgressViewController.h"

#define kSecondsForCompleteUpdate   3.0
#define kUpdateInterval             0.02

@interface ProgressViewController ()

@property (weak, nonatomic) IBOutlet ProgressView *progressView;
@property (weak, nonatomic) IBOutlet UIButton *startProgressButton;
@property (strong, nonatomic) NSTimer *timer;

@end

@implementation ProgressViewController

#pragma mark - IBActions

- (IBAction)startProgressTapped
{
    self.progressView.progress = 0.0;
    
    self.startProgressButton.enabled = NO;
    
    self.timer = [NSTimer timerWithTimeInterval:kUpdateInterval
                                         target:self
                                       selector:@selector(updateProgressView)
                                       userInfo:nil
                                        repeats:YES];
    
    [[NSRunLoop currentRunLoop] addTimer:self.timer forMode:NSDefaultRunLoopMode];
    
    [self.timer fire];
}

#pragma mark - Private Methods

- (void)updateProgressView;
{
    if (self.progressView.progress < 1.0)
    {
        self.progressView.progress += (kUpdateInterval / kSecondsForCompleteUpdate);
    }
    else
    {
        [self.timer invalidate];
        
        self.startProgressButton.enabled = YES;
    }
}

#pragma mark - View Lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.progressView.progress = 0.0;
}

@end
